require 'erb'
require 'json'

def download_server_json
  product_name = ARGV[0]
  config_root = File.expand_path('..', __FILE__)
  git_branch = `cd #{config_root}; git rev-parse --abbrev-ref HEAD`.chop
  dir_basename = File.basename config_root
  server_conf_url = "http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master/#{product_name}/#{git_branch}/#{dir_basename}/server.json"
  puts "Use server config url: #{server_conf_url}"
  system "curl #{server_conf_url} > #{config_root}/server.json"
end

def deploy_binding
  config_root = File.expand_path('..', __FILE__)
  server_conf = JSON(File.read("#{__dir__}/server.json"))
  binding
end

def generate_push_config
  template = ERB.new File.read("#{__dir__}/push_config.sh.erb"), nil, '>'
  script_content = template.result(deploy_binding)
  puts "\n\n\n******************* push_config content *******************\n\n\n"
  puts script_content
  File.open("#{__dir__}/push_config.sh", "w") { |f| f.write(script_content) }
end

def generate_pull_config
  template = ERB.new File.read("#{__dir__}/pull_config.sh.erb"), nil, '>'
  script_content = template.result(deploy_binding)
  puts "\n\n\n******************* pull_config content *******************\n\n\n"
  puts script_content
  File.open("#{__dir__}/pull_config.sh", "w") { |f| f.write(script_content) }
end

download_server_json
generate_push_config
generate_pull_config
