#!/usr/bin/env ruby

product_name = ARGV[0] # crm, jxc, bms
dir_name = ARGV[1] # dev, test, staging, prod
config_root = File.expand_path("../#{dir_name}", __FILE__)
if dir_name.nil?
  raise "Dir name is required!"
elsif !Dir.exists?(config_root)
  raise "Dir: #{config_root} not exists!"
end

puts "======================= config_root is: #{config_root} ======================="

git_config_url = "http://gitlab.ikcrm.com/ikcrm_common/servers_config/raw/master"
setup_url = "#{git_config_url}/setup.rb"
puts "Use setup url: #{setup_url}"
system "curl #{setup_url} > #{config_root}/setup.rb"

push_script_url = "#{git_config_url}/push_config.sh.erb"
puts "Use push script url: #{push_script_url}"
system "curl #{push_script_url} > #{config_root}/push_config.sh.erb"

pull_script_url = "#{git_config_url}/pull_config.sh.erb"
puts "Use pull script url: #{pull_script_url}"
system "curl #{pull_script_url} > #{config_root}/pull_config.sh.erb"

require "#{config_root}/setup.rb"

# Usage example:
# `ruby setup_script.rb crm prod` OR ./setup_script.rb crm prod
